@echo off

:: mp4 Quality -------------------------------
set quality=24 
:: ( quality: 20-26 useful, smaler better quality ) 

set GOPSize=250
:: ( GOPSize: short clips needs smaler value, useful minimum 50 )  

set fps=
:: ( fps: frames per second )  

:: Install Path ----------------------------
set "InstallPath=Z:\PROGRAMME\__GlobalTools\CMDTools"
:: ---------------------------------------------

if exist %InstallPath% GOTO check
echo --------------------------------------------------------
echo.
echo - Bitte Ornder anlegen und Tools hinein Kopieren
echo.
echo - (z.B. C:\cmdTools)
echo.
echo - Pfad bei "InstallPath" in Batch File anpassen
echo.
echo - Tools: avconv.exe(von FFmpeg); MediaInfo.exe(CLI) (und MediaInfo.dll); mp4creator.exe
echo.
echo --------------------------------------------------------
pause
exit

:check
if exist "%windir%\SysWOW64\avisynth.dll" GOTO checkTools
if not exist "%windir%\System32\avisynth.dll" GOTO Avisynth

:Avisynth

echo --------------------------------------
echo.
echo - Bitte Avisynth installieren
echo.
echo - druecke Key zum fortfahren 
echo.
echo --------------------------------------
pause
if exist "%InstallPath%\Avisynth_258.exe" (
	start "" "%InstallPath%\Avisynth_258.exe"
	) else (
		start "" "http://sourceforge.net/projects/avisynth2/files/"
		)
exit

:checkTools
if exist %InstallPath%\avconv.exe GOTO MedInf

echo --------------------------------------
echo.
echo - Bitte Installationspfad pruefen
echo.
echo - und FFmpeg installieren 
echo.
echo --------------------------------------
pause
start "" "http://ffmpeg.zeranoe.com/builds/win32/static/ffmpeg-git-4f7dfe1-win32-static.7z"
exit

:MedInf
if exist %InstallPath%\MediaInfo.exe GOTO mp4cre

echo --------------------------------------
echo.
echo - Bitte Media Info CLI installieren 
echo.
echo --------------------------------------
pause
start "" "http://sourceforge.net/projects/mediainfo/files/binary/mediainfo/0.7.48/MediaInfo_CLI_0.7.48_Windows_i386.zip/download"
exit

:mp4cre
if exist %InstallPath%\mp4creator.exe GOTO run

echo --------------------------------------
echo.
echo - Bitte mp4creator installieren
echo.
echo --------------------------------------
pause
start "" "http://downloads.sourceforge.net/mp4creator/mp4creator-win32-1.6.1d.zip"
exit


:run
set "input=%~1"

cd /d "%~dp1" 2>nul
cd /d %1 2>nul

set x1="%input%"
set x2="%cd%"

if "%input%"=="%CD%" GOTO folder
echo.
echo................................................................
echo.
echo..........converting Video-File.................................
echo.
echo................................................................
echo.

:: File Compression -------------------------------

if exist "%~n1_tmp.avs" del "%~n1_tmp.avs"
if exist "%~n1_video.h264" del "%~n1_video.h264"
if exist "%~n1_audio.aac" del "%~n1_audio.aac"
if exist "%~n1_x264.mp4" del "%~n1_x264.mp4"

chcp 1252
if %~x1 == .avi (	
	@echo AVISource^( "%input%" ^).FlipVertical^(^) >> "%~n1_tmp.avs"
	set infile="%~n1_tmp.avs"
	) else (
		set infile="%input%"
		)
chcp 850

if not "%fps%" == "" GOTO vid
FOR /F %%i in ( '%InstallPath%\mediainfo --Inform^=^"Video^;%%FrameRate%%^" %1' ) do set fps=%%i

:vid
echo.
echo..........................Audio Track:............................
echo.
%InstallPath%\avconv.exe -y -i %infile% -acodec aac -ab 160k -strict experimental -vn "%~n1_audio.aac"
echo.
echo..........................Video Track:............................
echo.
%InstallPath%\avconv.exe -i %infile% -vcodec libx264 -crf %quality% -r %fps% -pix_fmt yuv420p -profile main -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%~n1_video.h264"

%InstallPath%\mp4creator -create="%~n1_audio.aac" "%~n1_x264.mp4"
%InstallPath%\mp4creator -create="%~n1_video.h264" -r %fps% "%~n1_x264.mp4"
%InstallPath%\mp4creator -hint=1 "%~n1_x264.mp4"
%InstallPath%\mp4creator -hint=2 "%~n1_x264.mp4"
%InstallPath%\mp4creator -optimize "%~n1_x264.mp4"

echo.
echo..........................File Info:............................
echo.
%InstallPath%\mp4creator -list "%~n1_x264.mp4"


if exist "%~n1_tmp.avs" del "%~n1_tmp.avs"
if exist "%~n1_video.h264" del "%~n1_video.h264"
if exist "%~n1_audio.aac" del "%~n1_audio.aac"

GOTO end
:: ---------------------------------------------------

:: Folder Compression -------------------------------

:folder

echo.
echo................................................................
echo.
echo...........converting Frame-Sequence............................
echo.
echo................................................................
echo.

if not "%fps%" == "" GOTO comp
set fps=25

:comp

pushd %input%
setlocal enabledelayedexpansion
set number=0

for %%i in (*) do (
	set /a number=number+1
	set "file=%%i"
	)

if %number% LSS 251 set GOPSize=50

set ext=%file:~-4%
call set name=%%file:%ext%=%%
set newname=%name:~0,-4%

if %ext% == .exr GOTO compEXR 
 
set endframe=%name:~-4%

set frame=%endframe:~0,-3%

if not %frame% == 0 GOTO 4digits

set frame0=%endframe:~-3%
set frame1=%endframe:~0,-2%

if not %frame1% == 00 GOTO 3digits
set frame2=%endframe:~-2%
set /a startframe=%frame2%-%number%+1

GOTO next

:3digits
set /a startframe=%frame0%-%number%+1

GOTO next

:4digits
set /a startframe=%endframe%-%number%+1

:next

popd

set "var=%newname%%%04d%ext%"

if exist "%input%\..\%~n1_tmp.avs" del "%input%\..\%~n1_tmp.avs"
if exist "%input%\..\%newname%_video.h264" del "%input%\..\%newname%_video.h264"
if exist "%input%\..\_%newname%_x264.mp4" del "%input%\..\_%newname%_x264.mp4"

echo ImageReader^( "%input%\%var%", start=%startframe%, end=%endframe%, fps=%fps% ^).FlipVertical^(^) >> "%input%\..\%~n1_tmp.avs"

%InstallPath%\avconv.exe -i "%input%\..\%~n1_tmp.avs" -vcodec libx264 -crf %quality% -profile main -pix_fmt yuv420p -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%input%\..\%newname%_video.h264"

%InstallPath%\mp4creator -create="%input%\..\%newname%_video.h264" -r %fps% "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -hint=1 "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -hint=2 "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -optimize "%input%\..\_%newname%_x264.mp4"

echo.
echo..........................File Info:............................
echo.
%InstallPath%\mp4creator -list "%input%\..\_%newname%_x264.mp4"

if exist "%input%\..\%~n1_tmp.avs" del "%input%\..\%~n1_tmp.avs"
if exist "%input%\..\%newname%_video.h264" del "%input%\..\%newname%_video.h264"

GOTO end

:compEXR
set /P gamma="Set Gamma Value:"
:: ( gamma: gamma correction ) 

pushd %input%

if exist TMPframe* del TMPframe*
if exist *_tmp.png del *_tmp.png

for %%i in (*.exr) do ( 
	%InstallPath%\imf_copy.exe -v -g %gamma% "%%i" "%%~ni_tmp.png" png rgba
	) 

setlocal enabledelayedexpansion
set number=0
for %%i in (*_tmp.png) do (
	set /a number=number+1
	set "number1=000!number!"
	set "number2=!number1:~-4!"
	
	ren "%%i" "TMPframe_!number2!.png"
	)

if exist "%input%\..\%newname%_video.h264" del "%input%\..\%newname%_video.h264"
if exist "%input%\..\_%newname%_x264.mp4" del "%input%\..\_%newname%_x264.mp4"

%InstallPath%\avconv.exe -i "TMPframe_%%04d.png" -vcodec libx264 -crf %quality% -r %fps% -pix_fmt yuv420p -profile main -coder 1 -flags +loop+mv4 -cmp +chroma -partitions +parti8x8+parti4x4+partp8x8+partb8x8 -me_method umh -subq 8 -me_range 16 -g %GOPSize% -keyint_min 5 -sc_threshold 40 -i_qfactor 0.71 -b_strategy 2 -qcomp 0.6 -qmin 10 -qmax 51 -qdiff 4 -bf 3 -refs 4 -directpred 3 -trellis 1 -flags2 +wpred+mixed_refs+dct8x8+fastpskip -an -threads 0 -y "%input%\..\%newname%_video.h264"

%InstallPath%\mp4creator -create="%input%\..\%newname%_video.h264" -r %fps% "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -hint=1 "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -hint=2 "%input%\..\_%newname%_x264.mp4"
%InstallPath%\mp4creator -optimize "%input%\..\_%newname%_x264.mp4"

echo.
echo..........................File Info:............................
echo.
%InstallPath%\mp4creator -list "%input%\..\_%newname%_x264.mp4"

if exist TMPframe* del TMPframe*
if exist "%input%\..\%newname%_video.h264" del "%input%\..\%newname%_video.h264"

endlocal
popd


:end
echo.
echo................................................................
echo.
echo.....................converting done............................
echo.
echo................................................................
echo.

ping 127.0.0.0 -n 3 >nul
echo.
echo Window close in 15 Second
echo.
ping 127.0.0.0 -n 5 >nul
echo.
echo Window close in 10 Second
echo.
ping 127.0.0.0 -n 5 >nul
echo.
echo Window close in 5 Second
echo.
ping 127.0.0.0 -n 5 >nul
echo.
